
/*  	ccide - C Language Decision Table Code Generator 
	Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com


   BONUS.CPP.D
	Copyright 2012, David Topham, d t opham@gm ail. c om
	Used here by permission.

    	This file is part of ccide, the C Language Decision Table Code Generator.

   	Ccide is free software: you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
    	the Free Software Foundation, either version 3 of the License, or
   	(at your option) any later version.

    	Ccide is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with Ccide.  If not, see <http://www.gnu.org/licenses/> or
    	write to the Free Software Foundation, Inc., 51 Franklin St, 
    	Fifth Floor, Boston, MA 02110-1301 USA.
*/
//CCIDE_INLINE_CODE:
/*GENERATED_CODE: */
#ifndef __CCIDE_INLINE_C
#define __CCIDE_INLINE_C

/*ccide-0.6.6-1
ccide is Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com 
The code generated by ccide is covered by the same license as the source  
code(decision table) from which it is derived. If you created the source,  
you are free to do anything you like with the generated code, 
including incorporating it into or linking it with proprietary software.  
*/ 
static int ccide_group=1; 
#ifndef UINT_MAX 
#include "limits.h" 
#endif /* End if not defined UINT_MAX */ 
 
		/* Return rule number */ 
static int CCIDEFindRule(
	int nbrrules,  unsigned long ccide_table, unsigned long yes[], unsigned long no[]){ 
        int r=0; 
        unsigned long nstate; 
 
        nstate = UINT_MAX ^ ccide_table; 
 
        while ( 
		( (yes[r] & nstate) || (no[r]  & ccide_table) ) 
		 && ( ++r < nbrrules )  
	) {}; 
 
        return r; 
} 
 
static int CCIDEFindRuleYes(             /* Return rule number */
	int nbrrules, unsigned long ccide_table, unsigned long yes[]) 
{ 
        int r=0; 
        unsigned long nstate;
 
        nstate = UINT_MAX ^ ccide_table; 
        while ( (yes[r] & nstate) && ( ++r < nbrrules ) ) {}; 
        return r; 
} 
#endif /* End ifndef  __CCIDE_INLINE_C  */
/*END_GENERATED_CODE: */
#include <iostream>
using namespace std;
struct Emp
{
	int dept;
	int dep;
	int id;
};
const int N = 8;
int get_bonus( Emp e )
{
  int bonus = 0;
/*  manually coded version
if e.dept != 2 and e.dep > 5 and e.id <= 800  bonus = 1000;
else if e.dept == 2 and e.dep <= 5 and e.id <= 800  bonus = 200;
else bonus = 100;
*/

/* The small table and the big table are logically equivalent. twy */	
#ifndef USE_BIG_TABLE
//DECISION_TABLE:
//   Y  -  N | e.dept == 2
//   N  -  Y | e.dep > 5
//   N  -  N | e.id > 800
//______________________
//   -  X  - | bonus = 100;
//   X  -  - | bonus = 200; 
//   -  -  X | bonus = 1000;	
//END_TABLE:
//GENERATED_CODE: FOR TABLE_1.
//	3 Rules, 3 conditions, and 3 actions.
//	Table 1 rule order = 1 3 2 
 {	unsigned long CCIDE_table1_yes[3]={   1UL,   2UL,   0UL};
	unsigned long CCIDE_table1_no[3]= {   6UL,   5UL,   0UL};


	switch(CCIDEFindRule(3,
		  (e.dept == 2)
		| (e.dep > 5)<<1
		| (e.id > 800)<<2
		  ,CCIDE_table1_yes, CCIDE_table1_no)) {
	case  1:	//	Rule  3 
	    bonus = 1000;
	    break;
	case  0:	//	Rule  1 
	    bonus = 200;
	    break;
	case  2:	//	Rule  2 
	    bonus = 100;
	    break;
	} // End Switch
}
//END_GENERATED_CODE: FOR TABLE_1, by ccide-0.6.6-1  
#else
//DECISION_TABLE:
//   Y  Y  Y  Y  N  N  N  N | e.dept == 2
//   Y  Y  N  N  Y  Y  N  N | e.dep > 5
//   Y  N  Y  N  Y  N  Y  N | e.id > 800
//______________________
//   X  X  X  -  X  -  X  X | bonus = 100;
//   -  -  -  X  -  -  -  - | bonus = 200; 
//   -  -  -  -  -  X  -  - | bonus = 1000;	
//END_TABLE:	
//GENERATED_CODE: FOR TABLE_2.
//	8 Rules, 3 conditions, and 3 actions.
//	Table 2 rule order = 1 2 3 4 5 6 7 8 
 {	unsigned long CCIDE_table2_yes[8]={   7UL,   3UL,   5UL,   1UL,   6UL,   2UL,   4UL,   0UL};
	unsigned long CCIDE_table2_no[8]= {   0UL,   4UL,   2UL,   6UL,   1UL,   5UL,   3UL,   7UL};


	switch(CCIDEFindRule(8,
		  (e.dept == 2)
		| (e.dep > 5)<<1
		| (e.id > 800)<<2
		  ,CCIDE_table2_yes, CCIDE_table2_no)) {
	case  5:	//	Rule  6 
	    bonus = 1000;
	    break;
	case  3:	//	Rule  4 
	    bonus = 200;
	    break;
	case  0:	//	Rule  1 
	case  1:	//	Rule  2 
	case  2:	//	Rule  3 
	case  4:	//	Rule  5 
	case  6:	//	Rule  7 
	case  7:	//	Rule  8 
	    bonus = 100;
	    break;
	} // End Switch
}
//END_GENERATED_CODE: FOR TABLE_2, by ccide-0.6.6-1  
#endif

  return bonus;
}
int main ()
{
  Emp e[N] = { {2,6,900},{2,6,700},{2,4,850},{2,5,750},
               {1,10,950},{1,9,775},{1,3,975},{1,1,1}  
	     };
  cout<<"Testing Emplyee bonus plan decision table... " << endl;
  
  for( int i = 0; i < N; i++ )
  {	  
    cout << "Emp:" << i+1 << '\t' << "Bonus is $" 
	 << get_bonus(e[i]) << endl;
  }
  return 0;
}
