/** 
 * The hw class implements an application that tests ccide -L JAVA  < FOOBAR.java 

		ccide - C Language Decision Table Code Generator 

	Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com

    	This file is part of ccide, the C Language Decision Table Code Generator.

   	Ccide is free software: you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
    	the Free Software Foundation, either version 3 of the License, or
   	(at your option) any later version.

    	Ccide is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with Ccide.  If not, see <http://www.gnu.org/licenses/> or
    	write to the Free Software Foundation, Inc., 51 Franklin St, 
    	Fifth Floor, Boston, MA 02110-1301 USA.
*/

/* THISIS: hw.java.d */

//CCIDE_INLINE_CODE: 
/*GENERATED_CODE:*/

/*
ccide-C.m4
Copyright (C) 2002-2004,2010,2012; Thomas W. Young, e-mail:  ccide@twyoung.com
 * The code generated by ccide is covered by the same license as the source  
 * code(decision table) from which it is derived. If you created the source,  
 * you are free to do anything you like with the generated code, 
 * including incorporating it into or linking it with proprietary software.  
*/

class CCIDE {

    public static int CcideFindRule(               /* Return rule number */
	int nbrrules,  int ccide_table, int yes[], int no[]) {
        int r=0;
        int nstate;

        nstate = Integer.MAX_VALUE ^ ccide_table;

         while (
		 (
		  ((yes[r] & nstate) != 0)  || 
		  ((no[r]  & ccide_table) != 0 )
		 )
		 && ( ++r < nbrrules )
	) {  };
  	
        return r;
    }

    public static int CcideFindRuleYes(             /* Return rule number */
	int nbrrules, int ccide_table, int yes[]) {
        int r=0;
        int nstate;

        nstate = Integer.MAX_VALUE ^ ccide_table;
        while ( 
		( (yes[r] & nstate) != 0) && 
		  ( ++r < nbrrules )  
	) {};
        
        return r;
    }
}
/*END_GENERATED_CODE:*/
/*GENERATED_CODE: */
/* Substitution strings are: $$ and $@*/
/*END_GENERATED_CODE: */

class hw {
    public static void main(String[] args) {
        System.out.println("Hello World!"); //Display the string.
	String A,B,C,D,E; 
	int state=0;
	A = "A"; B = "B"; C = "C"; D = "D"; E = "E";
	
	for (int i = 0; i < args.length; i++) {
	        System.out.println(args[i]);    

		//DECISION_TABLE:
		//   Y  -  - | A.compareTo(args[i]) == 0
		//   -  Y  - | B.compareTo(args[i]) == 0
		//   -  -  Y | C.compareTo(args[i]) == 0
		// _____ |_________________________
		//   X  -  - | System.out.println("Got A!");
		//   -  X  - | System.out.println("Got B!");
		//   -  -  X | System.out.println("Got C!");
		//END_TABLE:
		/*GENERATED_CODE: FOR TABLE_1.*/
		/*	3 Rules, 3 conditions, and 3 actions.*/
		/*	Table 1 rule order = 1 2 3 */
		 {	int[] CCIDE_table1_yes=new int[] {1, 2, 4};


			switch(CCIDE.CcideFindRuleYes(3,(((A.compareTo(args[i]) == 0) ? 1: 0)|((B.compareTo(args[i]) == 0) ? 1: 0)<<1|((C.compareTo(args[i]) == 0) ? 1: 0)<<2) ,CCIDE_table1_yes))  { 
			/*CCIDE_1_2: */ case 2:	/*	Rule 3*/
			    System.out.println("Got C!");
			    break;
			/*CCIDE_1_1: */ case 1:	/*	Rule 2*/
			    System.out.println("Got B!");
			    break;
			/*CCIDE_1_0: */ case 0:	/*	Rule 1*/
			    System.out.println("Got A!");
			    break;
			} } /* End Switch*/
		/*END_GENERATED_CODE: FOR TABLE_1, by ccide-0.6.6-1  */
	}

	for (int i = 0; i < args.length; i++) {
	        System.out.println(args[i]);    

		//DECISION_TABLE:
		//   Y  -  - | A.compareTo(args[i]) == 0
		//   -  Y  - | B.compareTo(args[i]) == 0
		//   -  N  Y | C.compareTo(args[i]) == 0
		//   N  N  N | D.compareTo(args[i]) == 0
		// _____ |_________________________
		//   X  -  - | System.out.println("B: Got A!");
		//   -  X  - | System.out.println("B: Got B!");
		//   -  -  X | System.out.println("B: Got C!");
		//END_TABLE:
		/*GENERATED_CODE: FOR TABLE_2.*/
		/*	3 Rules, 4 conditions, and 3 actions.*/
		/*	Table 2 rule order = 2 1 3 */
		 {	int[] CCIDE_table2_yes=new int[] {2, 1, 4};
		int[] CCIDE_table2_no=new int[] {12, 8, 8};


			switch(CCIDE.CcideFindRule(   3,(((A.compareTo(args[i]) == 0) ? 1: 0)|((B.compareTo(args[i]) == 0) ? 1: 0)<<1|((C.compareTo(args[i]) == 0) ? 1: 0)<<2|((D.compareTo(args[i]) == 0) ? 1: 0)<<3) ,CCIDE_table2_yes, CCIDE_table2_no))  { 
			/*CCIDE_2_2: */ case 2:	/*	Rule 3*/
			    System.out.println("B: Got C!");
			    break;
			/*CCIDE_2_0: */ case 0:	/*	Rule 2*/
			    System.out.println("B: Got B!");
			    break;
			/*CCIDE_2_1: */ case 1:	/*	Rule 1*/
			    System.out.println("B: Got A!");
			    break;
			} } /* End Switch*/
		/*END_GENERATED_CODE: FOR TABLE_2, by ccide-0.6.6-1  */
	}

	for (int i = 0; i < args.length; i++) {
	        System.out.println(args[i]);    

		//DECISION_TABLE:
		//   Y | E.compareTo(args[i]) == 0
		//  _ |_________________________
		//   X | System.out.println("C: Got E!");
		//END_TABLE:
		/*GENERATED_CODE: FOR TABLE_3.*/
		/*	1 Rules, 1 conditions, and 1 actions.*/
		if(E.compareTo(args[i]) == 0) {
		   System.out.println("C: Got E!");
		}
		/*END_GENERATED_CODE: FOR TABLE_3, by ccide-0.6.6-1 */
	}
	   while(state<4) {
		//DECISION_TABLE:
		//   0  1  2  3 | state == $$
		// ________|_________________________
		//   0  1  2  3 | System.out.println("State=$$");
		//   1  2  3  4 | state = $$;
		//END_TABLE:
		/*GENERATED_CODE: FOR TABLE_4.*/
		/*	4 Rules, 4 conditions, and 8 actions.*/
		 {  switch(state ) {
			/*CCIDE_4_3: */ case 3:	/*	Rule 4*/
			    System.out.println("State=3");
			    state = 4;
			    break;
			/*CCIDE_4_2: */ case 2:	/*	Rule 3*/
			    System.out.println("State=2");
			    state = 3;
			    break;
			/*CCIDE_4_1: */ case 1:	/*	Rule 2*/
			    System.out.println("State=1");
			    state = 2;
			    break;
			/*CCIDE_4_0: */ case 0:	/*	Rule 1*/
			    System.out.println("State=0");
			    state = 1;
			    break;
		 } } /* End Switch*/ 
		/*END_GENERATED_CODE: FOR TABLE_4, by ccide-0.6.6-1  */
	   }  // End while state<4

	   for (int j = 0; j < args.length; j++) {
		//DECISION_TABLE:
		//   0  1  2  3 | state == $$
		//   Y  N  -  - | A.compareTo(args[j]) == 0
		// ________|_________________________
		//   0  1  2  3 | System.out.println("State=$$");
		//   1  2  3  4 | state = $$;
		//END_TABLE:
		/*GENERATED_CODE: FOR TABLE_5.*/
		/*	4 Rules, 5 conditions, and 8 actions.*/
		/*	Table 5 rule order = 1 2 3 4 */
		 {	int[] CCIDE_table5_yes=new int[] {17, 2, 4, 8};
		int[] CCIDE_table5_no=new int[] {0, 16, 0, 0};


			switch(CCIDE.CcideFindRule(   4,(((state == 0) ? 1: 0)|((state == 1) ? 1: 0)<<1|((state == 2) ? 1: 0)<<2|((state == 3) ? 1: 0)<<3|((A.compareTo(args[j]) == 0) ? 1: 0)<<4) ,CCIDE_table5_yes, CCIDE_table5_no))  { 
			/*CCIDE_5_3: */ case 3:	/*	Rule 4*/
			    System.out.println("State=3");
			    state = 4;
			    break;
			/*CCIDE_5_2: */ case 2:	/*	Rule 3*/
			    System.out.println("State=2");
			    state = 3;
			    break;
			/*CCIDE_5_1: */ case 1:	/*	Rule 2*/
			    System.out.println("State=1");
			    state = 2;
			    break;
			/*CCIDE_5_0: */ case 0:	/*	Rule 1*/
			    System.out.println("State=0");
			    state = 1;
			    break;
			} } /* End Switch*/
		/*END_GENERATED_CODE: FOR TABLE_5, by ccide-0.6.6-1  */
	   }  // End for j=...	
    }		
}
