/*  	ccide - C Language Decision Table Code Generator 
	Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com

    	This file is part of ccide, the C Language Decision Table Code Generator.

   	Ccide is free software: you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
    	the Free Software Foundation, either version 3 of the License, or
   	(at your option) any later version.

    	Ccide is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with Ccide.  If not, see <http://www.gnu.org/licenses/> or
    	write to the Free Software Foundation, Inc., 51 Franklin St, 
    	Fifth Floor, Boston, MA 02110-1301 USA.
*/

/* THISIS: if2rpnq.c.d 7/19/2012 */

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "if2rpn.h"

#define SET(S)    return (S);
#define SETN(N)   number=(N); 	SET(NUMBER); 
#define SETO(T)   token=(T);  	SET(OPERATOR);
 
/***********************GLOBAL VARIABLES******************/
TYPE stack[SSIZE+1];
int SP=0,number;		/* Stack Pointer */
TYPE token=SEPARATOR;

	 //      0                        5                       10
char *ttable[]={".", "n", "f", "|", "(", ")", "o", "=", "+", "-", "*", "/"};  /* Tokens */
/***********************LOCAL VARIABLES******************/
static int instate=1; 
static int ptbl[NTOK]={0,1,2,3,4,4,6,7,8,8,10,10};          /* Precedence table */

/***********************LOCAL FUNCTIONS*******************/

//CCIDE_INLINE_CODE:
/*GENERATED_CODE: */
#ifndef __CCIDE_INLINE_C
#define __CCIDE_INLINE_C

/*ccide-0.6.6-1
ccide is Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com 
The code generated by ccide is covered by the same license as the source  
code(decision table) from which it is derived. If you created the source,  
you are free to do anything you like with the generated code, 
including incorporating it into or linking it with proprietary software.  
*/ 
static int ccide_group=1; 
#ifndef UINT_MAX 
#include "limits.h" 
#endif /* End if not defined UINT_MAX */ 
 
		/* Return rule number */ 
static int CCIDEFindRule(
	int nbrrules,  unsigned long ccide_table, unsigned long yes[], unsigned long no[]){ 
        int r=0; 
        unsigned long nstate; 
 
        nstate = UINT_MAX ^ ccide_table; 
 
        while ( 
		( (yes[r] & nstate) || (no[r]  & ccide_table) ) 
		 && ( ++r < nbrrules )  
	) {}; 
 
        return r; 
} 
 
static int CCIDEFindRuleYes(             /* Return rule number */
	int nbrrules, unsigned long ccide_table, unsigned long yes[]) 
{ 
        int r=0; 
        unsigned long nstate;
 
        nstate = UINT_MAX ^ ccide_table; 
        while ( (yes[r] & nstate) && ( ++r < nbrrules ) ) {}; 
        return r; 
} 
#endif /* End ifndef  __CCIDE_INLINE_C  */
/*END_GENERATED_CODE: */

/***********************GLOBAL FUNCTIONS******************/
int GetPrecedence() {
	return ptbl[token]>ptbl[TOS];
}

#ifdef PSEUDO_INPUT
TYPE GetToken(){
	//DECISION_TABLE:
	//   1  2  3  4  5  6  7  8  9 10 11 |instate==$$
	// _____________________________________
	//   X  -  -  -  -  -  -  -  -  -  - |SETN(17);	
	//   -  X  -  -  -  -  -  -  -  -  - |SETO(TIMES);
	//   -  -  X  -  -  -  -  -  -  -  - |token=LEFT_PAREN; SET(LEFT_PAREN);
	//   -  -  -  X  -  -  -  -  -  -  - |SETN(5);	
	//   -  -  -  -  X  -  -  -  -  -  - |SETO(PLUS);
	//   -  -  -  -  -  X  -  -  -  -  - |SETN(13);	
	//   -  -  -  -  -  -  X  -  -  -  - |token=RIGHT_PAREN;SET(RIGHT_PAREN);
	//   -  -  -  -  -  -  -  X  -  -  - |SETO(MINUS);
	//   -  -  -  -  -  -  -  -  X  -  - |SETN(41);	
	//   -  -  -  -  -  -  -  -  -  X  - |SETO(EQUAL);
	//   -  -  -  -  -  -  -  -  -  -  X |SET(EMPTY);
	//END_TABLE:
	//GENERATED_CODE: FOR TABLE_1.
	//	11 Rules, 11 conditions, and 11 actions.
	 {  switch(instate) {	
		case 11:		//  Rule 11  
		    SET(EMPTY);
		    break;
		case 10:		//  Rule 10  
		    SETO(EQUAL);
		    break;
		case 9:		//  Rule  9  
		    SETN(41);
		    break;
		case 8:		//  Rule  8  
		    SETO(MINUS);
		    break;
		case 7:		//  Rule  7  
		    token=RIGHT_PAREN;SET(RIGHT_PAREN);
		    break;
		case 6:		//  Rule  6  
		    SETN(13);
		    break;
		case 5:		//  Rule  5  
		    SETO(PLUS);
		    break;
		case 4:		//  Rule  4  
		    SETN(5);
		    break;
		case 3:		//  Rule  3  
		    token=LEFT_PAREN; SET(LEFT_PAREN);
		    break;
		case 2:		//  Rule  2  
		    SETO(TIMES);
		    break;
		case 1:		//  Rule  1  
		    SETN(17);
		    break;
	 }
	}
	//END_GENERATED_CODE: FOR TABLE_1, by ccide-0.6.6-1  

	
	instate++;
}
#endif


void PushToken() {

	//DECISION_TABLE:
	//   N  - |SP<SSIZE
	//________________________
	//   X  - |fprintf(stderr,"Stack space exceeded\n");
	//   X  - |exit(2);
	//   -  X |SP++;
	//   -  X |TOS=token; 
	//END_TABLE:
	//GENERATED_CODE: FOR TABLE_2.
	//	2 Rules, 1 conditions, and 4 actions.
	if( !(SP<SSIZE) )  {
	   fprintf(stderr,"Stack space exceeded\n");
	   exit(2);
	} else { 
	   SP++;
	   TOS=token;
	}
	//END_GENERATED_CODE: FOR TABLE_2, by ccide-0.6.6-1  

	
}

void OutputNumber() {

	//DECISION_TABLE:
	//   Y |1
	//________________________
	//   X |printf("%i ", number);
	//END_TABLE:
	//GENERATED_CODE: FOR TABLE_3.
	//	1 Rules, 1 conditions, and 1 actions.
	if( (1) )  {
	   printf("%i ", number);
	}
	//END_GENERATED_CODE: FOR TABLE_3, by ccide-0.6.6-1  

	
}

void OutputToken(){  
	
	//DECISION_TABLE:
	//   1 |$$==1
	//________________________
	//   X |printf("%s ",token);
	//END_TABLE:
	//GENERATED_CODE: FOR TABLE_4.
	//	1 Rules, 1 conditions, and 1 actions.
	if( (1==1) )  {
	   printf("%s ",token);
	}
	//END_GENERATED_CODE: FOR TABLE_4, by ccide-0.6.6-1  

}

void Pop(){ 
	
	//DECISION_TABLE:
	//   Y  N |SP<1
	//________________________
	//   X  - |fprintf(stderr,"");
	//   X  - |exit(1);
	//   -  X |SP--;
	//END_TABLE:
	//GENERATED_CODE: FOR TABLE_5.
	//	2 Rules, 1 conditions, and 3 actions.
	if( (SP<1) )  {
	   fprintf(stderr,"");
	   exit(1);
	} else { 
	   SP--;
	}
	//END_GENERATED_CODE: FOR TABLE_5, by ccide-0.6.6-1  

}

void PopToQueue() {
	
	printf("%s ",ttable[TOS]);
	Pop();
}


/* End of IF2RNQ.C */
